## org.apache.http.impl.conn
Class BasicClientConnectionManager

    java.lang.Object
      org.apache.http.impl.conn.BasicClientConnectionManager

All Implemented Interfaces:
  ClientConnectionManager

    @ThreadSafe
    public class BasicClientConnectionManager

extends Object
implements ClientConnectionManager

A connection manager for a single connection. This connection manager maintains only one active connection at a time. Even though this class is thread-safe it ought to be used by one execution thread only.

BasicClientConnManager will make an effort to reuse the connection for subsequent requests with the same `route`. It will, however, close the existing connection and open it for the given route, if the route of the persistent connection does not match that of the connection request. If the connection has been already been allocated `IllegalStateException` is thrown.

This connection manager implementation can be used inside a EJB container instead of `PoolingClientConnectionManager`.

Since:
  4.2

Field Summary
`static String` `MISUSE_MESSAGE` The message to be logged on multiple allocation.

Constructor Summary
`BasicClientConnectionManager()`
`BasicClientConnectionManager(SchemeRegistry schreg)` Creates a new simple connection manager.

Method Summary
`void` `closeExpiredConnections()` Closes all expired connections in the pool.
`void` `closeIdleConnections(long idletime, TimeUnit tunit)` Closes idle connections in the pool.
`protected ClientConnectionOperator` `createConnectionOperator(SchemeRegistry schreg)`
`protected void` `finalize()`
`SchemeRegistry` `getSchemeRegistry()` Obtains the scheme registry used by this manager.
`void` `releaseConnection(ManagedClientConnection conn, long keepalive, TimeUnit tunit)` Releases a connection for use by others.
`ClientConnectionRequest` `requestConnection(HttpRoute route, Object state)` Returns a new `ClientConnectionRequest`, from which a `ManagedClientConnection` can be obtained or the request can be aborted.
`void` `shutdown()` Shuts down this connection manager and releases allocated resources.

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### MISUSE_MESSAGE

    public static final String MISUSE_MESSAGE

  The message to be logged on multiple allocation.

  See Also:
    Constant Field Values

Constructor Detail

### BasicClientConnectionManager

    public BasicClientConnectionManager(SchemeRegistry schreg)

  Creates a new simple connection manager.

  Parameters:
    `schreg` - the scheme registry

### BasicClientConnectionManager

    public BasicClientConnectionManager()

Method Detail

### finalize

    protected void finalize()
                     throws Throwable

  Overrides:
    `finalize` in class `Object`
  Throws:
    `Throwable`

### getSchemeRegistry

    public SchemeRegistry getSchemeRegistry()

  Description copied from interface: `ClientConnectionManager`
  Obtains the scheme registry used by this manager.

  Specified by:
    `getSchemeRegistry` in interface `ClientConnectionManager`
  Returns:
    the scheme registry, never `null`

### createConnectionOperator

    protected ClientConnectionOperator createConnectionOperator(SchemeRegistry schreg)

### requestConnection

    public final ClientConnectionRequest requestConnection(HttpRoute route,
                                                           Object state)

  Description copied from interface: `ClientConnectionManager`
  Returns a new `ClientConnectionRequest`, from which a `ManagedClientConnection` can be obtained or the request can be aborted.

  Specified by:
    `requestConnection` in interface `ClientConnectionManager`

### releaseConnection

    public void releaseConnection(ManagedClientConnection conn,
                                  long keepalive,
                                  TimeUnit tunit)

  Description copied from interface: `ClientConnectionManager`
  Releases a connection for use by others. You may optionally specify how long the connection is valid to be reused. Values <= 0 are considered to be valid forever. If the connection is not marked as reusable, the connection will not be reused regardless of the valid duration. If the connection has been released before, the call will be ignored.

  Specified by:
    `releaseConnection` in interface `ClientConnectionManager`
  Parameters:
    `conn` - the connection to release
    `keepalive` - the duration of time this connection is valid for reuse
    `tunit` - the unit of time validDuration is measured in
  See Also:
    `ClientConnectionManager.closeExpiredConnections()`

### closeExpiredConnections

    public void closeExpiredConnections()

  Description copied from interface: `ClientConnectionManager`
  Closes all expired connections in the pool. Open connections in the pool that have not been used for the timespan defined when the connection was released will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision.

  Specified by:
    `closeExpiredConnections` in interface `ClientConnectionManager`

### closeIdleConnections

    public void closeIdleConnections(long idletime,
                                     TimeUnit tunit)

  Description copied from interface: `ClientConnectionManager`
  Closes idle connections in the pool. Open connections in the pool that have not been used for the timespan given by the argument will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision All expired connections will also be closed.

  Specified by:
    `closeIdleConnections` in interface `ClientConnectionManager`
  Parameters:
    `idletime` - the idle time of connections to be closed
    `tunit` - the unit for the `idletime`
  See Also:
    `ClientConnectionManager.closeExpiredConnections()`

### shutdown

    public void shutdown()

  Description copied from interface: `ClientConnectionManager`
  Shuts down this connection manager and releases allocated resources. This includes closing all connections, whether they are currently used or not.

  Specified by:
    `shutdown` in interface `ClientConnectionManager`

Copyright © 1999-2013 The Apache Software Foundation. All Rights Reserved.